/**
 * The nodereference explorer javascript file.
 * It assigns actions to the widget buttons and draws the
 * dialog. It contains several other fixes now (see code comments).
 * All setting are indexed for multiple values per widget yet.
 */

//define name space
Drupal.nodereference_explorer = {};

/**
 * Widget actions
 * TODO the behaviors currently depend on the settings object containing the IDs
 * of each widget to attach itself to. This isn't compatible with the normal
 * add more widgets behavior of CCK.
 */
Drupal.behaviors.nodereference_explorer = function (context) {
  for (var id in Drupal.settings.nodereference_explorer) {
    $('#' + id + '-nid-nid-wrapper', context).parents('.nodereference-explorer:not(.nodereference-explorer-processed)').each(function (index, domElement) {
      var wrapper = $(this);
      wrapper.data('nodereference_explorer', id);
      for (var action in Drupal.nodereference_explorer.actions) {
        var button = $('<input class="nodereference-explorer-' + action + '-button nodereference-explorer-button" type="button" />');
        button.val(Drupal.t(action));
        button.bind('click', { nodereference_explorer: id, button: action }, function(objEvent) {
          if ($(this).hasClass('nodereference-explorer-browse-button'))
        	  $(this).attr('disabled', 'disabled'); //prevent multiple clicking
          var widget = $(this).parents('.nodereference-explorer');
          Drupal.nodereference_explorer.actions[objEvent.data.button](widget);
          if ($(this).hasClass('nodereference-explorer-browse-button'))
            setTimeout('$(".nodereference-explorer-browse-button").removeAttr("disabled")', 3500);//; //enable button again after some time (ms)
        }); 
        button.insertAfter('#' + id + '-nid-nid'); //actions are populate in reverse order, therefore put the last action (browse) at first
      }
      wrapper.addClass('nodereference-explorer-processed');
    });
  }
};

/**
 * Remove button action
 *
 * This action also sets up the actions object. The remove function is an
 * example of the most minimal button that can be added to a
 * nodereference_explorer widget.
 *
 * TODO The buttons need to have names that can be set separately from their
 * function. They also need some kind of weight so their order can be
 * controlled.
 */
Drupal.nodereference_explorer.actions = {
  remove: function (widget) {
    $('.form-autocomplete', widget).val('').change();
  }
};