/*
 * Preview behavior
 */

Drupal.behaviors.nodereference_explorer_preview = function (context) {
  for (var id in Drupal.settings.nodereference_explorer_preview) {
    $('#' + id + '-nid-nid-wrapper', context).parents('.nodereference-explorer:not(.nodereference-explorer-preview-processed)').each(function (index, domElement) {
      var wrapper = $(this);
      var title = $('.form-autocomplete', wrapper).val();
      wrapper.data('nodereference_explorer_preview', title);
      $('.form-autocomplete', wrapper).bind("change", function(objEvent) {
        var widget = $(this).parents('.nodereference-explorer');
        var val = $(this).val();
        var oldValue = widget.data('nodereference_explorer_preview');
        //only trigger when values are different
        if (val != oldValue) {
          var preview = $('.nodereference-explorer-preview', widget);
          var id = widget.data('nodereference_explorer');
          widget.data('nodereference_explorer_preview', val);
          $.getJSON(Drupal.settings.nodereference_explorer_preview[id].path, { val: val }, function(data, textStatus) {
            if (data.data) {
              $(preview).html(data.data);
            }
            else {
              $(preview).text('');
            }
          });
        }
      });
      wrapper.addClass('nodereference-explorer-preview-processed');
    });
  }
};