// $Id: explorer.selection.js,v 1.1 2009/06/24 09:27:19 gnindl Exp $

/**
 * @file
 * explorer.selection.js
 *
 * This behavior synchronizes the selections in the view with the stored value
 * that will be sent back to the autocomplete widget when the dialog is closed.
 */
Drupal.behaviors.nodereference_explorer_selection = function(context) {
/**
 * Tab related events, e. g. show/hide filter a form or
 * render the initial display
 */
	
  //FIX for browser hiding of multiple identical ids of filter forms
  $('.views-widget .form-item', context).show();
  //render dialog tabs
  $('div.nodereference-explorer-tabset ul.nodereference-explorer-tabs', context).tabs(); //{ fx: { opacity: "toggle" }} );

  //disable and hide default display because it's causing inconvinient id problems with the underlying CCK form, 
  //e. g. exposed widget form fields disappear
  $('div.nodereference-explorer-tabset ul.nodereference-explorer-tabs', context).tabs('select', 1);
  $('div.nodereference-explorer-tabset ul.nodereference-explorer-tabs', context).tabs('disable', 0);
  $('.nodereference-explorer-tab:first').hide();
  
  //display filter for selected tab
  $('div.nodereference-explorer-tabset ul.nodereference-explorer-tabs', context).bind('tabsshow', function(event, ui) {
	//FIX for browser hiding of multiple identical ids of filter forms
	$('.views-widget .form-item', context).show();
	
    // TODO the selected node needs to be highlighted. to reproduce, open
    // dialog, choose a tab, navigate to the page where the selected node is
    // highlighted and find a node ID on the same page, switch to another tab,
    // select the node with the ID you chose from the previous tab, and switch
    // back to that tab.
    $('.nodereference-explorer-views-filters').hide();
    var display = $(ui.panel).attr('id');
    $('#filter-'+display).show();
  });

  //fix for hover over active table cell (column sorted)
  $('.views-item-selectable', context).mouseover(function() {
    var background = $(this).css('background-color'); //'background');
    //alert($background);
    $('td', this).css('background-color', background);
  }).mouseout(function() {
    $('td', this).css('background-color', '');
  });

  //select view item visually
  $('.views-item-selectable', context).click(function(eventObject) {
    if (eventObject.target.type !== 'radio') {
      $(':radio', this).trigger('click');
    }
  });

  $('.views-item-selectable input:radio', context).hide().click(function (eventObject) {
    var title = $(this).val();
    $('#edit-selection').val(title);
    $(this).parents('.view-content').find('.views-item-selectable').each(function () {
      $(this).removeClass('viewItemSelected');
    });
    $(this).parents('.views-item-selectable').addClass('viewItemSelected');
  });
  var selected = $('#edit-selection').val();
  $('input:radio[value="'+selected+'"]', context).click();
};
