<?php
// $Id: theme.inc,v 1.2 2009/06/24 09:27:19 gnindl Exp $
/**
 * @file
 * theme.inc
 * Template preprocess function for preparing necessary template variables and doing
 * theme related tasks.
 */

/**
 * Prepare the dialog template variables and add css,
 * as well as javascript and javascript settings
 * @param $vars template variables
 */
function template_preprocess_nodereference_explorer_dialog(&$vars) {
}

/**
 * Theme autocomplete widget
 * @param $element widget
 * @return rendered representation of autocomplete
 */
function theme_nodereference_explorer($element) {
  $field = content_fields($element['#field_name'], $element['#type_name']);
  $theme = _nodereference_explorer_widget_parse_settings($field, 'theme');
  $dialog = _nodereference_explorer_widget_parse_settings($field, 'dialog'); //retrieve dialog settings

  //custom action and selection js
  nodereference_explorer_add_js('explorer');
  nodereference_explorer_add_css('explorer.form');

  switch ($dialog['api']) {
    case 'modalframe':
      _theme_nodereference_explorer_dialog($theme);
     // drupal_add_css(JQUERY_UI_PATH . '/themes/'.$theme['css']); //overall dialog window
      modalframe_parent_js();
      nodereference_explorer_add_js('explorer.modalframe');
      break;
    case NODE_REFERENCE_EXPLORER_MODULE_NAME:
    default:
      nodereference_explorer_add_js('explorer.dialog');
     _theme_nodereference_explorer_dialog($theme);
      //add dialog related js files
      $jq_ui_files = array('ui.dialog', 'ui.tabs');

      if ($dialog['draggable']) //can the dialog window be moved
        array_push($jq_ui_files, 'ui.draggable');

      if ($dialog['resizable']) //can the dialog window be resized
        array_push($jq_ui_files, 'ui.resizable');

      if ($dialog['bgiframe']) //patch for IE 6 z-Index problem, i. e. overlay of controls over dialog
        nodereference_explorer_add_js('jquery.bgiframe', TRUE);
        jquery_ui_add($jq_ui_files);
      break;
  }

  if ($field['widget']['content_preview'] == '1') {
    //custom action and selection js
    nodereference_explorer_add_js('explorer.preview');
  }

  return $element['#children'];
}

/**
 * Template for selectable row fields. This is used by grid,
 * list and unformatted view plugins.
 * @param $vars template variables
 */
function template_preprocess_nodereference_explorer_view_row_fields_selectable(&$vars) {
  template_preprocess_views_view_fields($vars);
  if ($vars['view']->display_handler->options['row_plugin'] == 'fields_selectable') {
    $element = array(
      '#type' => 'radio',
      '#id' => form_clean_id('selectable'),
      '#name' => 'nodereference-explorer-dialog',
      '#return_value' => $vars['fields']['title']->raw . ' [nid:'. $vars['fields']['nid']->raw .']',
    );
    $vars['fields']['nid']->content .= drupal_render($element);
  }
}

function _theme_nodereference_explorer_dialog($theme) {
  switch ($theme['css']) {
    case '<module>':
      nodereference_explorer_add_css('explorer.all');
      break;
    case '<global>':
      //do nothring
      break;
   default: //jquery_ui theme
     $path = JQUERY_UI_PATH . '/themes/'. $theme['css'];
     $css_files = file_scan_directory($path, '\.all\.css$');
     if (empty($css_files)) //include all css files, if no overall css header can be found
       $css_files = file_scan_directory($path, '\.css$');

     foreach($css_files as $css)
         drupal_add_css($css->filename);
   }
}
